﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Museum
{
    /// <summary>
    /// Логика взаимодействия для MainMenu.xaml
    /// </summary>
    public partial class MainMenu : Window
    {
        public MainMenu()
        {
            InitializeComponent();
            Museum_MatveyContext context = new Museum_MatveyContext();
            var ListEvemt = context.ListEvents;

            foreach (var evemt in ListEvemt)
            {
                if (evemt.NumberSeats >= 1 && evemt.DateEvents > DateTime.Now)
                {
                    ListEventCombo.Items.Add($"{evemt.Id}");
                }
            }

            foreach (var x in ListEvemt)
            {
                if (x.NumberSeats >= 1)
                {
                    ListEvents.Items.Add($"Мероприятие: {x.NameEvents} Номер({x.Id})\n" +
                    $"Описание: {x.DiscriptionEvents}\n" +
                    $"Дата проведения: {x.DateEvents}\n" +
                    $"Мест осталось: {x.NumberSeats}\n" +
                    $"Цена: {x.PriseEvents}\n" +
                    $"Что-бы узнать время проведения,\n" +
                    $"Позвоните по номеру {x.PhoneNumber}");
                }
                else if(x.NumberSeats < 1)
                {
                    ListEvents.Items.Add($"Мероприятие: {x.NameEvents} Номер({x.Id})\n" +
                   $"Описание: {x.DiscriptionEvents}\n" +
                   $"Дата проведения: {x.DateEvents}\n" +
                   $"Мест осталось: \bМест больше нет!\b\n" +
                   $"Цена: Не продаётся\n" +
                   $"Что-бы узнать время проведения,\n" +
                   $"Позвоните по номеру {x.PhoneNumber}");
                }
                else if (x.DateEvents > DateTime.Now)
                {
                    ListEvents.Items.Add($"Мероприятие: {x.NameEvents} Номер({x.Id})\n" +
                   $"Описание: {x.DiscriptionEvents}\n" +
                   $"Дата проведения: {x.DateEvents} - \bУже прошло!\b \n" +
                   $"Мест осталось: \bМест больше нет!\b\n" +
                   $"Цена: Не продаётся\n" +
                   $"Что-бы узнать время проведения,\n" +
                   $"Позвоните по номеру {x.PhoneNumber}");
                }
            }


        }

        private void ListEvents_Scroll(object sender, System.Windows.Controls.Primitives.ScrollEventArgs e)
        {

        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Museum_MatveyContext contextBuy = new Museum_MatveyContext();
            var ListEvemt = contextBuy.ListEvents;

            var num = ListEvemt.SingleOrDefault(x => x.Id == Convert.ToInt32(ListEventCombo.Text));

            num.NumberSeats = num.NumberSeats - 1;
            ListEvemt.Update(num);
            contextBuy.SaveChanges();

            Museum_MatveyContext contextTicket = new Museum_MatveyContext();
            var tikets = contextTicket.Tikets;

            Random rnd = new Random();

            int idTiketGenera = Convert.ToInt32(ListEventCombo.Text) + DateTime.Today.Year + rnd.Next(13,  300);
            Tiket newTiket = new Tiket()
            {
                DataOwner = $"Имя владельца: {UserSaveData.Name}\n" +
                $"Логин владельца: {UserSaveData.Login}",
                IdEvent = Convert.ToInt32(ListEventCombo.Text),
                IdTicket = idTiketGenera,
            };
            tikets.Add(newTiket);
            contextTicket.SaveChanges();

            MessageBox.Show($"Вы успешно купили билет!\n" +
                $"Сфотографируйте его для того что бы\n" +
                $"Потом показать его!\n" +
                $"Номер вашего билета: {idTiketGenera}");

            Login login = new Login();
            login.Show();
            this.Hide();
        }
    }
}
